This section will allow you to install a proper local environment step by step for Pilote application using VSCode IDE.

## VSCode

### Install VSCode

Installation for VSCode can be found here: [Installation of VSCode](https://code.visualstudio.com/).

### Extensions

Installation of Extension is explained here: [Installation of Extensions](https://code.visualstudio.com/docs/editor/extension-gallery).

Here are the list of important extensions to install:

- Prettier - Code formatter
- ES7 React/Redux/GraphQL/React-Native snippets
- GitLens - Git supercharged
- Markdown Preview

Optional extensions:

- CSS Peek
- Auto Rename Tag
- indent-rainbow
- TabOut
- Liveshare (pair programming extension)

### User settings

Open the project with VSCode and add the following code into .vscode/settings.json:

```
{
  "workbench.colorCustomizations": {
     /* Put anything you like here */
  },
  "editor.snippetSuggestions": "top",
  "editor.tabSize": 2,
  "editor.formatOnSave": true,
  "diffEditor.ignoreTrimWhitespace": false,
  "window.zoomLevel": 0,
  "gitlens.advanced.messages": {
      "suppressShowKeyBindingsNotice": true
  },
  "breadcrumbs.enabled": true,
  "workbench.settings.editor": "json",
  "editor.tabSize": 2,
  "editor.formatOnSave": true,
  "editor.formatOnPaste": true
}
```

If this file is not empty, you can simply add the following lines to it:

```
  "gitlens.advanced.messages": {
    "suppressShowKeyBindingsNotice": true
  },
  "breadcrumbs.enabled": true,
  "workbench.settings.editor": "json",
  "editor.formatOnSave": true,
  "diffEditor.ignoreTrimWhitespace": false,
  "window.zoomLevel": 0,
```

## Git

The project is using Gitlab, you will need to install Git to checkout the project.
Installation for Git can be found here: [Installation of Git](https://git-scm.com/).

## Node
Node.js® is a JavaScript runtime built on Chrome's V8 JavaScript engine.

!!! warning "Version 14 & 16"

For our projects you will need to have a version manager for node such as [**n**](https://www.npmjs.com/package/n) on linux and [**nvm**](https://github.com/coreybutler/nvm-windows) on windows. Install both 14 and 16 versions.

## Yarn

Yarn is used as package manager for this project. Feel free to use the one you prefer but we advice to install yarn as all the documentation is described with this package manager.
Installation for yarn can be found here: [Installation of Yarn](https://classic.yarnpkg.com/fr/docs/install/).

## Docker

Docker is a tool designed to make it easier to create, deploy, and run applications by using containers. Containers allow a developer to package up an application with all of the parts it needs, such as libraries and other dependencies, and ship it all out as one package. By doing so, thanks to the container, the developer can rest assured that the application will run on any other Linux machine regardless of any customized settings that machine might have that could differ from the machine used for writing and testing the code.

### Install Docker

Installation of Docker can be found here: [Installation of Docker](https://www.docker.com/get-started).

### Install Docker-Compose

Installation of Docker-Compose (according to your OS) is explained here: [Installation of Docker-Compose](https://docs.docker.com/compose/install/).
